# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

from tvtk.tvtk_classes.color_transfer_control_points_item import ColorTransferControlPointsItem


class CompositeControlPointsItem(ColorTransferControlPointsItem):
    """
    CompositeControlPointsItem - Control points for
    
    Superclass: ColorTransferControlPointsItem
    
    CompositeControlPointsItem draws the control points of a
    PiecewiseFunction and a ColorTransferFunction.
    
    See Also:
    
    ControlPointsItem ColorTransferControlPointsItem
    CompositeTransferFunctionItem PiecewisePointHandleItem
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCompositeControlPointsItem, obj, update, **traits)
    
    points_function = traits.Int(3, enter_set=True, auto_set=False, help=\
        """
        points_function controls wether the points represent the
        color_transfer_function, opacity_transfer_function or both. If
        color_points_function, only the points of the color_transfer
        function are used. If opacity_points_function, only the points of
        the Opacity function are used If color_and_opacity_points_function,
        the points of both functions are shared by both functions.
        color_and_opacity_points_function by default. Note: Set the mode
        before the functions are set. color_points_function is not fully
        supported.
        """
    )
    def _points_function_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPointsFunction,
                        self.points_function)

    def _get_opacity_function(self):
        return wrap_vtk(self._vtk_obj.GetOpacityFunction())
    def _set_opacity_function(self, arg):
        old_val = self._get_opacity_function()
        self._wrap_call(self._vtk_obj.SetOpacityFunction,
                        deref_vtk(arg))
        self.trait_property_changed('opacity_function', old_val, arg)
    opacity_function = traits.Property(_get_opacity_function, _set_opacity_function, help=\
        """
        
        """
    )

    use_opacity_point_handles = traits.Bool(False, help=\
        """
        If use_opacity_point_handles is true, when the current point is
        double clicked, a PiecewisePointHandleItem will show up so
        that the sharpness and mid point can be adjusted in the scene
        with those handles False by default.
        """
    )
    def _use_opacity_point_handles_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseOpacityPointHandles,
                        self.use_opacity_point_handles)

    _updateable_traits_ = \
    (('opacity', 'GetOpacity'), ('switch_points_mode',
    'GetSwitchPointsMode'), ('end_points_removable',
    'GetEndPointsRemovable'), ('points_function', 'GetPointsFunction'),
    ('color_fill', 'GetColorFill'), ('user_bounds', 'GetUserBounds'),
    ('use_opacity_point_handles', 'GetUseOpacityPointHandles'),
    ('visible', 'GetVisible'), ('tooltip_notation', 'GetTooltipNotation'),
    ('end_points_y_movable', 'GetEndPointsYMovable'),
    ('end_points_x_movable', 'GetEndPointsXMovable'), ('current_point',
    'GetCurrentPoint'), ('screen_point_radius', 'GetScreenPointRadius'),
    ('use_index_for_x_series', 'GetUseIndexForXSeries'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('debug',
    'GetDebug'), ('valid_bounds', 'GetValidBounds'), ('label',
    'GetLabel'), ('width', 'GetWidth'), ('reference_count',
    'GetReferenceCount'), ('tooltip_precision', 'GetTooltipPrecision'),
    ('tooltip_label_format', 'GetTooltipLabelFormat'))
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'color_fill', 'current_point',
    'end_points_removable', 'end_points_x_movable',
    'end_points_y_movable', 'label', 'opacity', 'points_function',
    'screen_point_radius', 'switch_points_mode', 'tooltip_label_format',
    'tooltip_notation', 'tooltip_precision', 'use_index_for_x_series',
    'use_opacity_point_handles', 'user_bounds', 'valid_bounds', 'visible',
    'width'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CompositeControlPointsItem, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit CompositeControlPointsItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View(([], [], ['color_fill', 'current_point',
            'end_points_removable', 'end_points_x_movable',
            'end_points_y_movable', 'label', 'opacity', 'points_function',
            'screen_point_radius', 'switch_points_mode', 'tooltip_label_format',
            'tooltip_notation', 'tooltip_precision', 'use_index_for_x_series',
            'use_opacity_point_handles', 'user_bounds', 'valid_bounds', 'visible',
            'width']),
            title='Edit CompositeControlPointsItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CompositeControlPointsItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

