# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

from tvtk.tvtk_classes.projected_tetrahedra_mapper import ProjectedTetrahedraMapper


class OpenGLProjectedTetrahedraMapper(ProjectedTetrahedraMapper):
    """
    OpenGLProjectedTetrahedraMapper - open_gl implementation of PT
    
    Superclass: ProjectedTetrahedraMapper
    
    
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOpenGLProjectedTetrahedraMapper, obj, update, **traits)
    
    use_floating_point_frame_buffer = tvtk_base.true_bool_trait(help=\
        """
        Set/get whether to use floating-point rendering buffers rather
        than the default.
        """
    )
    def _use_floating_point_frame_buffer_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseFloatingPointFrameBuffer,
                        self.use_floating_point_frame_buffer_)

    _updateable_traits_ = \
    (('global_warning_display', 'GetGlobalWarningDisplay'),
    ('scalar_mode', 'GetScalarMode'), ('progress_text',
    'GetProgressText'), ('debug', 'GetDebug'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('use_floating_point_frame_buffer', 'GetUseFloatingPointFrameBuffer'),
    ('reference_count', 'GetReferenceCount'), ('progress', 'GetProgress'),
    ('blend_mode', 'GetBlendMode'))
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'use_floating_point_frame_buffer', 'blend_mode',
    'scalar_mode', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OpenGLProjectedTetrahedraMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit OpenGLProjectedTetrahedraMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View((['use_floating_point_frame_buffer'], ['blend_mode',
            'scalar_mode'], []),
            title='Edit OpenGLProjectedTetrahedraMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OpenGLProjectedTetrahedraMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

